<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateAnnualPlanTransformative extends Migration
{

	/**
	 * Run the migrations.
	 *
	 * @return void
	 */
	public function up()
	{
		Schema::create('annual_plan_transformative', function (Blueprint $table) {
			$table->increments('id');
			$table->integer('annual_plan')->unsigned();
			$table->integer('trans_op_id')->unsigned();
			$table->foreign('trans_op_id')
				->references('id')
				->on('transformative_objective_program')
				->onDelete('cascade')
				->onUpdate('cascade');
			$table->foreign('annual_plan')
				->references('id')
				->on('annual_plans')
				->onDelete('cascade')
				->onUpdate('cascade');
		});
	}

	/**
	 * Reverse the migrations.
	 *
	 * @return void
	 */
	public function down()
	{
		Schema::drop('annual_plan_transformative');
	}
}
